'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = wrapTestFunction;

var _testController = require('../test-controller');

var _testController2 = _interopRequireDefault(_testController);

var _getCallsite = require('../../errors/get-callsite');

var _getCallsite2 = _interopRequireDefault(_getCallsite);

var _runtime = require('../../errors/runtime');

var _testRunTracker = require('../common/hybrid/test-run-tracker');

var _testRunTracker2 = _interopRequireDefault(_testRunTracker);

var _testRun = require('../../errors/test-run');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function processTestFnError(err) {
    if (err && err.isTestCafeError) return err;

    if (err && err.constructor === _runtime.APIError) return new _testRun.UncaughtErrorInTestCode(err.rawMessage, err.callsite);

    if (err instanceof Error) {
        var callsite = (0, _getCallsite2.default)(err);
        var isAssertionError = err.name === 'AssertionError' || err.constructor.name === 'AssertionError';

        return isAssertionError ? new _testRun.ExternalAssertionLibraryError(err, callsite) : new _testRun.UncaughtErrorInTestCode(err, callsite);
    }

    return new _testRun.UncaughtNonErrorObjectInTestCode(err);
}

function wrapTestFunction(fn) {
    var _this = this;

    return function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(testRun) {
            var result, controller, markeredfn;
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            // NOTE: fn() result used for testing purposes
                            result = null;
                            controller = new _testController2.default(testRun);
                            markeredfn = _testRunTracker2.default.addTrackingMarkerToFunction(testRun.id, fn);


                            _testRunTracker2.default.ensureEnabled();

                            _context.prev = 4;
                            _context.next = 7;
                            return markeredfn(controller);

                        case 7:
                            result = _context.sent;
                            _context.next = 13;
                            break;

                        case 10:
                            _context.prev = 10;
                            _context.t0 = _context['catch'](4);
                            throw processTestFnError(_context.t0);

                        case 13:

                            // NOTE: check if the last command in the test
                            // function is missing the `await` keyword.
                            controller._checkForMissingAwait();

                            return _context.abrupt('return', result);

                        case 15:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, _this, [[4, 10]]);
        }));
        return function (_x) {
            return ref.apply(this, arguments);
        };
    }();
}
module.exports = exports['default'];