'use strict';

exports.__esModule = true;
exports.DragDestinationIsInvisibleError = exports.DragDestinationNotFoundError = exports.ActionElementIsInvisibleError = exports.ActionElementNotFoundError = exports.DragDestinationSelectorTypeError = exports.ActionSelectorTypeError = exports.ActionStringArgumentError = exports.ActionOptionsTypeError = exports.ActionBooleanOptionError = exports.ActionPositiveIntegerOptionError = exports.ActionIntegerOptionError = exports.ExternalAssertionLibraryError = exports.UncaughtNonErrorObjectInTestCode = exports.UncaughtErrorInTestCode = exports.UncaughtErrorOnPage = exports.MissingAwaitError = undefined;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _category = require('./category');

var _category2 = _interopRequireDefault(_category);

var _type = require('./type');

var _type2 = _interopRequireDefault(_type);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Base
//--------------------------------------------------------------------
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var TestRunErrorBase = function TestRunErrorBase(category, type) {
    (0, _classCallCheck3.default)(this, TestRunErrorBase);

    this.isTestCafeError = true;
    this.category = category;
    this.type = type;
    this.callsite = null;
};

var ActionOptionErrorBase = function (_TestRunErrorBase) {
    (0, _inherits3.default)(ActionOptionErrorBase, _TestRunErrorBase);

    function ActionOptionErrorBase(type, optionName, actualValue) {
        (0, _classCallCheck3.default)(this, ActionOptionErrorBase);

        var _this = (0, _possibleConstructorReturn3.default)(this, _TestRunErrorBase.call(this, _category2.default.actionError, type));

        _this.optionName = optionName;
        _this.actualValue = actualValue;
        return _this;
    }

    return ActionOptionErrorBase;
}(TestRunErrorBase);

var ActionError = function (_TestRunErrorBase2) {
    (0, _inherits3.default)(ActionError, _TestRunErrorBase2);

    function ActionError(type) {
        (0, _classCallCheck3.default)(this, ActionError);
        return (0, _possibleConstructorReturn3.default)(this, _TestRunErrorBase2.call(this, _category2.default.actionError, type));
    }

    return ActionError;
}(TestRunErrorBase);

var UncaughtError = function (_TestRunErrorBase3) {
    (0, _inherits3.default)(UncaughtError, _TestRunErrorBase3);

    function UncaughtError(type) {
        (0, _classCallCheck3.default)(this, UncaughtError);
        return (0, _possibleConstructorReturn3.default)(this, _TestRunErrorBase3.call(this, _category2.default.uncaughtError, type));
    }

    return UncaughtError;
}(TestRunErrorBase);

// Synchronization errors
//--------------------------------------------------------------------


var MissingAwaitError = exports.MissingAwaitError = function (_TestRunErrorBase4) {
    (0, _inherits3.default)(MissingAwaitError, _TestRunErrorBase4);

    function MissingAwaitError(callsite) {
        (0, _classCallCheck3.default)(this, MissingAwaitError);

        var _this4 = (0, _possibleConstructorReturn3.default)(this, _TestRunErrorBase4.call(this, _category2.default.synchronizationError, _type2.default.missingAwaitError));

        _this4.callsite = callsite;
        return _this4;
    }

    return MissingAwaitError;
}(TestRunErrorBase);

// Uncaught errors
//--------------------------------------------------------------------


var UncaughtErrorOnPage = exports.UncaughtErrorOnPage = function (_UncaughtError) {
    (0, _inherits3.default)(UncaughtErrorOnPage, _UncaughtError);

    function UncaughtErrorOnPage(errMsg, pageDestUrl) {
        (0, _classCallCheck3.default)(this, UncaughtErrorOnPage);

        var _this5 = (0, _possibleConstructorReturn3.default)(this, _UncaughtError.call(this, _type2.default.uncaughtErrorOnPage));

        _this5.errMsg = errMsg;
        _this5.pageDestUrl = pageDestUrl;
        return _this5;
    }

    return UncaughtErrorOnPage;
}(UncaughtError);

var UncaughtErrorInTestCode = exports.UncaughtErrorInTestCode = function (_UncaughtError2) {
    (0, _inherits3.default)(UncaughtErrorInTestCode, _UncaughtError2);

    function UncaughtErrorInTestCode(err, callsite) {
        (0, _classCallCheck3.default)(this, UncaughtErrorInTestCode);

        var _this6 = (0, _possibleConstructorReturn3.default)(this, _UncaughtError2.call(this, _type2.default.uncaughtErrorInTestCode));

        _this6.errMsg = String(err);
        _this6.callsite = callsite;
        return _this6;
    }

    return UncaughtErrorInTestCode;
}(UncaughtError);

var UncaughtNonErrorObjectInTestCode = exports.UncaughtNonErrorObjectInTestCode = function (_UncaughtError3) {
    (0, _inherits3.default)(UncaughtNonErrorObjectInTestCode, _UncaughtError3);

    function UncaughtNonErrorObjectInTestCode(obj) {
        (0, _classCallCheck3.default)(this, UncaughtNonErrorObjectInTestCode);

        var _this7 = (0, _possibleConstructorReturn3.default)(this, _UncaughtError3.call(this, _type2.default.uncaughtNonErrorObjectInTestCode));

        _this7.objType = typeof obj === 'undefined' ? 'undefined' : (0, _typeof3.default)(obj);
        _this7.objStr = String(obj);
        return _this7;
    }

    return UncaughtNonErrorObjectInTestCode;
}(UncaughtError);

// Assertion errors
//--------------------------------------------------------------------


var ExternalAssertionLibraryError = exports.ExternalAssertionLibraryError = function (_TestRunErrorBase5) {
    (0, _inherits3.default)(ExternalAssertionLibraryError, _TestRunErrorBase5);

    function ExternalAssertionLibraryError(err, callsite) {
        (0, _classCallCheck3.default)(this, ExternalAssertionLibraryError);

        var _this8 = (0, _possibleConstructorReturn3.default)(this, _TestRunErrorBase5.call(this, _category2.default.assertionError, _type2.default.externalAssertionLibraryError));

        _this8.errMsg = String(err);
        _this8.callsite = callsite;
        return _this8;
    }

    return ExternalAssertionLibraryError;
}(TestRunErrorBase);

// Action parameters errors
//--------------------------------------------------------------------


var ActionIntegerOptionError = exports.ActionIntegerOptionError = function (_ActionOptionErrorBas) {
    (0, _inherits3.default)(ActionIntegerOptionError, _ActionOptionErrorBas);

    function ActionIntegerOptionError(optionName, actualValue) {
        (0, _classCallCheck3.default)(this, ActionIntegerOptionError);
        return (0, _possibleConstructorReturn3.default)(this, _ActionOptionErrorBas.call(this, _type2.default.actionIntegerOptionError, optionName, actualValue));
    }

    return ActionIntegerOptionError;
}(ActionOptionErrorBase);

var ActionPositiveIntegerOptionError = exports.ActionPositiveIntegerOptionError = function (_ActionOptionErrorBas2) {
    (0, _inherits3.default)(ActionPositiveIntegerOptionError, _ActionOptionErrorBas2);

    function ActionPositiveIntegerOptionError(optionName, actualValue) {
        (0, _classCallCheck3.default)(this, ActionPositiveIntegerOptionError);
        return (0, _possibleConstructorReturn3.default)(this, _ActionOptionErrorBas2.call(this, _type2.default.actionPositiveIntegerOptionError, optionName, actualValue));
    }

    return ActionPositiveIntegerOptionError;
}(ActionOptionErrorBase);

var ActionBooleanOptionError = exports.ActionBooleanOptionError = function (_ActionOptionErrorBas3) {
    (0, _inherits3.default)(ActionBooleanOptionError, _ActionOptionErrorBas3);

    function ActionBooleanOptionError(optionName, actualValue) {
        (0, _classCallCheck3.default)(this, ActionBooleanOptionError);
        return (0, _possibleConstructorReturn3.default)(this, _ActionOptionErrorBas3.call(this, _type2.default.actionBooleanOptionError, optionName, actualValue));
    }

    return ActionBooleanOptionError;
}(ActionOptionErrorBase);

var ActionOptionsTypeError = exports.ActionOptionsTypeError = function (_ActionError) {
    (0, _inherits3.default)(ActionOptionsTypeError, _ActionError);

    function ActionOptionsTypeError(actualType) {
        (0, _classCallCheck3.default)(this, ActionOptionsTypeError);

        var _this12 = (0, _possibleConstructorReturn3.default)(this, _ActionError.call(this, _type2.default.actionOptionsTypeError));

        _this12.actualType = actualType;
        return _this12;
    }

    return ActionOptionsTypeError;
}(ActionError);

var ActionStringArgumentError = exports.ActionStringArgumentError = function (_ActionError2) {
    (0, _inherits3.default)(ActionStringArgumentError, _ActionError2);

    function ActionStringArgumentError(argumentName, actualType) {
        (0, _classCallCheck3.default)(this, ActionStringArgumentError);

        var _this13 = (0, _possibleConstructorReturn3.default)(this, _ActionError2.call(this, _type2.default.actionStringArgumentError));

        _this13.argumentName = argumentName;
        _this13.actualType = actualType;
        return _this13;
    }

    return ActionStringArgumentError;
}(ActionError);

var ActionSelectorTypeError = exports.ActionSelectorTypeError = function (_ActionError3) {
    (0, _inherits3.default)(ActionSelectorTypeError, _ActionError3);

    function ActionSelectorTypeError(actualType) {
        (0, _classCallCheck3.default)(this, ActionSelectorTypeError);

        var _this14 = (0, _possibleConstructorReturn3.default)(this, _ActionError3.call(this, _type2.default.actionSelectorTypeError));

        _this14.actualType = actualType;
        return _this14;
    }

    return ActionSelectorTypeError;
}(ActionError);

var DragDestinationSelectorTypeError = exports.DragDestinationSelectorTypeError = function (_ActionError4) {
    (0, _inherits3.default)(DragDestinationSelectorTypeError, _ActionError4);

    function DragDestinationSelectorTypeError(actualType) {
        (0, _classCallCheck3.default)(this, DragDestinationSelectorTypeError);

        var _this15 = (0, _possibleConstructorReturn3.default)(this, _ActionError4.call(this, _type2.default.dragDestinationSelectorTypeError));

        _this15.actualType = actualType;
        return _this15;
    }

    return DragDestinationSelectorTypeError;
}(ActionError);

// Action execution errors
//--------------------------------------------------------------------


var ActionElementNotFoundError = exports.ActionElementNotFoundError = function (_ActionError5) {
    (0, _inherits3.default)(ActionElementNotFoundError, _ActionError5);

    function ActionElementNotFoundError() {
        (0, _classCallCheck3.default)(this, ActionElementNotFoundError);
        return (0, _possibleConstructorReturn3.default)(this, _ActionError5.call(this, _type2.default.actionElementNotFoundError));
    }

    return ActionElementNotFoundError;
}(ActionError);

var ActionElementIsInvisibleError = exports.ActionElementIsInvisibleError = function (_ActionError6) {
    (0, _inherits3.default)(ActionElementIsInvisibleError, _ActionError6);

    function ActionElementIsInvisibleError() {
        (0, _classCallCheck3.default)(this, ActionElementIsInvisibleError);
        return (0, _possibleConstructorReturn3.default)(this, _ActionError6.call(this, _type2.default.actionElementIsInvisibleError));
    }

    return ActionElementIsInvisibleError;
}(ActionError);

var DragDestinationNotFoundError = exports.DragDestinationNotFoundError = function (_ActionError7) {
    (0, _inherits3.default)(DragDestinationNotFoundError, _ActionError7);

    function DragDestinationNotFoundError() {
        (0, _classCallCheck3.default)(this, DragDestinationNotFoundError);
        return (0, _possibleConstructorReturn3.default)(this, _ActionError7.call(this, _type2.default.dragDestinationNotFoundError));
    }

    return DragDestinationNotFoundError;
}(ActionError);

var DragDestinationIsInvisibleError = exports.DragDestinationIsInvisibleError = function (_ActionError8) {
    (0, _inherits3.default)(DragDestinationIsInvisibleError, _ActionError8);

    function DragDestinationIsInvisibleError() {
        (0, _classCallCheck3.default)(this, DragDestinationIsInvisibleError);
        return (0, _possibleConstructorReturn3.default)(this, _ActionError8.call(this, _type2.default.dragDestinationIsInvisibleError));
    }

    return DragDestinationIsInvisibleError;
}(ActionError);